#!/bin/bash
# Copyright 2020 Douglas Eadline deadline@limulus-computing.com
# This code is licensed under the GNU Public General Public License
# which is available from http://www.gnu.org/copyleft/gpl.html
#
# squeuecommand.sh - runs Slum squeue command for various parameters
# (see Slum docs for details) Also it unpacks the condensed node 
# list format using scontrol (a little sed mojo needed to swap 
# new list with old list due to the possible "[ ]" in the string.)
squeue  -o "%i %P %j %u %p %t %M %C %D %N" >/tmp/.squeuecommand
while IFS= read -r line
do
#  DEBUG line: echo $line
  NODELIST=$(echo "$line"|gawk '{print $10}')
  if [ "$NODELIST" != "" ] && [ "$NODELIST" != "NODELIST" ]; then 
    EXP_NODELIST=$(scontrol show hostname $NODELIST| paste -d, -s )
    ESC_NODELIST=$(echo $NODELIST|sed 's/\[/\\\[/g'|sed 's/\]/\\\]/g')
    echo $line|sed "s/$ESC_NODELIST/$EXP_NODELIST/g"
  else
    echo $line
  fi
done < "/tmp/.squeuecommand"
rm /tmp/.squeuecommand
